summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Andrew Clemons2017-08-26 16:37:44 +0200
committer David Spencer2017-09-02 11:19:44 +0200
commitf948c9d8a2fdc466bcbc937b887731e29af05e12 (patch)
tree9cb27babac6beb705ca3f92091adc375ab4619a3
parentf1eb54fb5c11bcc76eadf63598cb49cab2e07f93 (diff)
downloadslackbuilds-f948c9d8a2fdc466bcbc937b887731e29af05e12.tar.gz
system/ripgrep: Added (line oriented search tool).
Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
-rw-r--r--system/ripgrep/README13
-rw-r--r--system/ripgrep/ripgrep-mkvendortarball.sh34
-rw-r--r--system/ripgrep/ripgrep.SlackBuild188
-rw-r--r--system/ripgrep/ripgrep.info84
-rw-r--r--system/ripgrep/slack-desc19
5 files changed, 338 insertions, 0 deletions
diff --git a/system/ripgrep/README b/system/ripgrep/README
new file mode 100644
index 0000000000..18f21fb3a8
--- /dev/null
+++ b/system/ripgrep/README
@@ -0,0 +1,13 @@
+ripgrep - line oriented search tool
+
+ripgrep is a line oriented search tool that combines the usability of
+The Silver Searcher (similar to ack) with the raw speed of GNU grep.
+
+By default, the slackbuild requires all crate dependencies to be downloaded
+individually. Optionally, if you already have cargo-vendor installed, you can
+create a "vendored" tarball which contains all the crate dependencies exploded
+into a single directory and then compressed together as a tarball.
+
+The script ripgrep-mkvendortarball.sh will generate this for you. The
+slackbuild will automatically use this tarball if found in the current
+directory.
diff --git a/system/ripgrep/ripgrep-mkvendortarball.sh b/system/ripgrep/ripgrep-mkvendortarball.sh
new file mode 100644
index 0000000000..6d5c8e4eae
--- /dev/null
+++ b/system/ripgrep/ripgrep-mkvendortarball.sh
@@ -0,0 +1,34 @@
+#!/bin/sh
+
+# Script to build a vendored tarball for ripgrep
+
+# Copyright 2017 Andrew Clemons, Wellington New Zealand
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+set -e
+
+PRGNAM=ripgrep
+VERSION=${VERSION:-0.6.0}
+
+rm -rf "$PRGNAM-$VERSION" "$PRGNAM-$VERSION-vendor.tar.gz"
+tar xvf "$PRGNAM-$VERSION.tar.gz"
+cd "$PRGNAM-$VERSION"
+cargo vendor
+tar cvfz ../"$PRGNAM-$VERSION-vendor.tar.gz" vendor
diff --git a/system/ripgrep/ripgrep.SlackBuild b/system/ripgrep/ripgrep.SlackBuild
new file mode 100644
index 0000000000..a4e4369aad
--- /dev/null
+++ b/system/ripgrep/ripgrep.SlackBuild
@@ -0,0 +1,188 @@
+#!/bin/sh
+
+# Slackware build script for ripgrep
+
+# Copyright 2017 Andrew Clemons, Wellington New Zealand
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=ripgrep
+VERSION=${VERSION:-0.6.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+
+# build offline
+# configuration tells cargo to use the configured directory
+# for dependencies intead of downloading from crates.io
+mkdir .cargo
+cat << EOF >> .cargo/config
+[source.crates-io]
+registry = 'https://github.com/rust-lang/crates.io-index'
+replace-with = 'vendored-sources'
+
+[source.vendored-sources]
+directory = '$(pwd)/vendor'
+EOF
+
+if [ -e $CWD/$PRGNAM-$VERSION-vendor.tar.gz ] ; then
+ tar xvf $CWD/$PRGNAM-$VERSION-vendor.tar.gz
+else
+ # deps and versions come from Cargo.lock
+ mkdir vendor
+ (
+ cd vendor
+
+ for dependency in aho-corasick=0.6.3 \
+ ansi_term=0.9.0 \
+ atty=0.2.2 \
+ bitflags=0.9.1 \
+ bytecount=0.1.7 \
+ cfg-if=0.1.2 \
+ clap=2.26.0 \
+ crossbeam=0.2.10 \
+ encoding_rs=0.6.11 \
+ env_logger=0.4.3 \
+ fnv=1.0.5 \
+ fs2=0.4.2 \
+ kernel32-sys=0.2.2 \
+ lazy_static=0.2.8 \
+ libc=0.2.29 \
+ log=0.3.8 \
+ memchr=1.0.1 \
+ memmap=0.5.2 \
+ num_cpus=1.6.2 \
+ regex=0.2.2 \
+ regex-syntax=0.4.1 \
+ same-file=0.1.3 \
+ simd=0.1.1 \
+ simd=0.2.0 \
+ strsim=0.6.0 \
+ term_size=0.3.0 \
+ textwrap=0.7.0 \
+ thread_local=0.3.4 \
+ unicode-segmentation=1.2.0 \
+ unicode-width=0.1.4 \
+ unreachable=1.0.0 \
+ utf8-ranges=1.0.0 \
+ vec_map=0.8.0 \
+ void=1.0.2 \
+ walkdir=1.0.7 \
+ winapi=0.2.8 \
+ winapi-build=0.1.1; do
+ dep="$(echo "$dependency" | cut -d= -f1)"
+ ver="$(echo "$dependency" | cut -d= -f2)"
+
+ tar xvf $CWD/$dep-$ver.crate
+
+ touch $dep-$ver/.cargo-ok
+
+ # generate checksum
+ {
+ printf "{\n"
+ printf ' "files": {\n'
+
+ (
+ cd $dep-$ver
+ find . -type f -print0 | xargs -0 sha256sum | sed -n '/\.cargo-checksum\.json/!p' | sed 's/\.\///;s/^\([^ ]*\)[[:space:]][[:space:]]*\(.*\)$/"\2":"\1",/'
+ ) | sed '$ s/,$//'
+
+ printf " },\n"
+ printf ' "package": "'
+
+ sha256sum "$CWD/$dep-$ver.crate" | cut -f1 -d' ' | sed 's/$/"/'
+
+ printf "}\n"
+ } | python -c "import sys, json; data = sys.stdin.read(); print json.dumps(json.loads(data), sort_keys=True, indent=4, separators=(',', ' : '))" > $dep-$ver/.cargo-checksum.json
+ done
+ )
+fi
+
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+cargo build --release
+
+mkdir -p $PKG/usr/bin/
+
+install -m 755 target/release/rg $PKG/usr/bin
+
+mkdir -p $PKG/usr/share/bash-completion/completions/
+find target/release -name rg.bash-completion -exec install -m644 {} $PKG/usr/share/bash-completion/completions/rg \;
+
+mkdir -p $PKG/usr/share/zsh/site-functions/
+find target/release -name _rg.ps1 -exec install -m644 {} $PKG/usr/share/zsh/site-functions/_rg \;
+
+mkdir -p $PKG/usr/man/man1
+install -m644 doc/rg.1 $PKG/usr/man/man1/rg.1
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a CHANGELOG.md COPYING LICENSE-MIT README.md UNLICENSE $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/ripgrep/ripgrep.info b/system/ripgrep/ripgrep.info
new file mode 100644
index 0000000000..c0ecec926f
--- /dev/null
+++ b/system/ripgrep/ripgrep.info
@@ -0,0 +1,84 @@
+PRGNAM="ripgrep"
+VERSION="0.6.0"
+HOMEPAGE="https://github.com/BurntSushi/ripgrep"
+DOWNLOAD="https://github.com/BurntSushi/ripgrep/archive/0.6.0.tar.gz \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/aho-corasick/aho-corasick-0.6.3.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/ansi_term/ansi_term-0.9.0.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/atty/atty-0.2.2.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/bitflags/bitflags-0.9.1.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/bytecount/bytecount-0.1.7.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/cfg-if/cfg-if-0.1.2.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/clap/clap-2.26.0.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/crossbeam/crossbeam-0.2.10.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/encoding_rs/encoding_rs-0.6.11.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/env_logger/env_logger-0.4.3.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/fnv/fnv-1.0.5.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/fs2/fs2-0.4.2.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/kernel32-sys/kernel32-sys-0.2.2.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/lazy_static/lazy_static-0.2.8.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/libc/libc-0.2.29.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/log/log-0.3.8.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/memchr/memchr-1.0.1.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/memmap/memmap-0.5.2.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/num_cpus/num_cpus-1.6.2.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/regex/regex-0.2.2.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/regex-syntax/regex-syntax-0.4.1.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/same-file/same-file-0.1.3.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/simd/simd-0.1.1.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/simd/simd-0.2.0.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/strsim/strsim-0.6.0.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/term_size/term_size-0.3.0.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/textwrap/textwrap-0.7.0.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/thread_local/thread_local-0.3.4.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/unicode-segmentation/unicode-segmentation-1.2.0.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/unicode-width/unicode-width-0.1.4.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/unreachable/unreachable-1.0.0.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/utf8-ranges/utf8-ranges-1.0.0.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/vec_map/vec_map-0.8.0.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/void/void-1.0.2.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/walkdir/walkdir-1.0.7.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/winapi/winapi-0.2.8.crate \
+ https://crates-io.s3-us-west-1.amazonaws.com/crates/winapi-build/winapi-build-0.1.1.crate"
+MD5SUM="a563f222b125f0df8d4e5dd92076e7b6\
+ f2904b4b227389e7453f14b769bdbe5b \
+ 1af8116948ced56c372f1ca6c6a8d07d \
+ 4203872eac0f8af60c75ce62d6ce9c85 \
+ 8db34042da9ec719905b996a5b7182e1 \
+ 535e536a91445a13a49e81611d5ae957 \
+ a71478e7dbff428e4fa0a328dc4a2712 \
+ 236d9f46687cc238f6b46ef501a7258d \
+ 034ef44a3d9e776f8762e617a3eff775 \
+ 013f3c2b499c1c6529086cfc308c816f \
+ fe1872f7c0d006fbc2b6212eaa42d56f \
+ e7ddc209eea405ae99b2635bb8dfac2c \
+ 4450f645d80db300f568420990eae6c8 \
+ 9d033cc2daa6924420a4a89e6705773f \
+ 4f1b30ca715275fdbc0696a8fb60c850 \
+ df9c12d536d3b1978764a719efe65e71 \
+ 3aeec0abc69e407a94677199cd6a0b4b \
+ 046c7f6cbfec17e33a7868d2743f91a6 \
+ c4816a3b17b74c0d7e9a8ffeda801e50 \
+ 393ca202bd5c4304c3ea90fb5cc7617f \
+ 5604a7f31b772bfb8b1d92eb82ce1c73 \
+ bc864dd8474a0c6dac7d492b7dec392b \
+ 072d3fe97570a02bac3c62844a6ee593 \
+ 66f350525cb05cd095f2a8261a8fd450 \
+ 1b856d3402bbb696ca5a54e43abec89c \
+ 681ab621ae3c59e5f8e9c49ceac6ee5a \
+ ef6c6bda7a4b8de56b53329783b7976c \
+ 545749d9786ab9f584576d036315d039 \
+ 8d3fbc736a60102fa220dcae70bc6102 \
+ 006dd221f179cceeedb8ddcad9ce7814 \
+ 4576769468adf019f6500d3a84b7f68c \
+ b390278bbea483da591b1bc026be5fa2 \
+ 7293a4349a42c9b7ef8866cca981ed83 \
+ 8b65613d99e7251fb8ff5ccafdf70cc3 \
+ 689203efc084fc0f1d1f74f5d354ae75 \
+ ce2dc8c8b14cc6cc93cf872a0df02aaf \
+ b44489eb4799c4fabac3fceb48de54f7 \
+ c900e7dbce808ff8ced375077b17a163"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="rust"
+MAINTAINER="Andrew Clemons"
+EMAIL="andrew.clemons@gmail.com"
diff --git a/system/ripgrep/slack-desc b/system/ripgrep/slack-desc
new file mode 100644
index 0000000000..7b758c475d
--- /dev/null
+++ b/system/ripgrep/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+ripgrep: ripgrep (line oriented search tool)
+ripgrep:
+ripgrep: ripgrep is a line oriented search tool that combines the usability of
+ripgrep: The Silver Searcher (similar to ack) with the raw speed of GNU grep.
+ripgrep:
+ripgrep: https://github.com/BurntSushi/ripgrep
+ripgrep:
+ripgrep:
+ripgrep:
+ripgrep:
+ripgrep: